--beginvalidatingquery 
IF EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME = 'SchemaVersion') 
    BEGIN 
    declare @major int = 10, @minor int = 0, @patch int = 32    
    IF EXISTS (SELECT 1 FROM dbo.SchemaVersion WHERE Major = @major AND Minor = @minor AND Patch = @patch) 
        select 0,'Already correct database version' 
    ELSE 
        select 1, 'Upgrading database' 
    END 
ELSE 
    select -1, 'Not an EPiServer Commerce database' 
--endvalidatingquery 

PRINT N'Altering Table [dbo].[LineItemReportData]...';
GO

ALTER TABLE [dbo].[LineItemReportData] ALTER COLUMN [Id] BIGINT NOT NULL;
GO

PRINT N'Altering Table [dbo].[OrderReportData]...';
GO
 
ALTER TABLE [dbo].[OrderReportData] DROP CONSTRAINT PK_OrderReportData;
ALTER TABLE [dbo].[OrderReportData] ALTER COLUMN [Id] BIGINT NOT NULL;
ALTER TABLE [dbo].[OrderReportData] ADD  CONSTRAINT [PK_OrderReportData] PRIMARY KEY CLUSTERED ([Id] ASC);
GO 
 
--beginUpdatingDatabaseVersion 
INSERT INTO dbo.SchemaVersion(Major, Minor, Patch, InstallDate) VALUES(10, 0, 32, GETUTCDATE()) 
GO 
--endUpdatingDatabaseVersion 
