--beginvalidatingquery 
IF EXISTS (SELECT 1 FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = 'dbo' AND TABLE_NAME = 'SchemaVersion') 
    BEGIN 
    declare @major int = 10, @minor int = 0, @patch int = 33    
    IF EXISTS (SELECT 1 FROM dbo.SchemaVersion WHERE Major = @major AND Minor = @minor AND Patch = @patch) 
        select 0,'Already correct database version' 
    ELSE 
        select 1, 'Upgrading database' 
    END 
ELSE 
    select -1, 'Not an EPiServer Commerce database' 
--endvalidatingquery 
PRINT N'Dropping Index [dbo].[SerializableCart].[IDX_SerializableCart_Indexed_Modified]...';


GO

IF EXISTS(SELECT 1 FROM sys.indexes WHERE name='IDX_SerializableCart_Indexed_Modified' AND object_id = OBJECT_ID('SerializableCart'))
	BEGIN
        DROP INDEX [IDX_SerializableCart_Indexed_Modified]
        ON [dbo].[SerializableCart];
    END


GO
PRINT N'Creating Index [dbo].[SerializableCart].[IDX_SerializableCart_Indexed_Modified]...';


GO
CREATE NONCLUSTERED INDEX [IDX_SerializableCart_Indexed_Modified]
    ON [dbo].[SerializableCart]([Modified] ASC)
    INCLUDE([Name]);


GO
PRINT N'Creating Procedure [dbo].[ecf_SerializableCart_DeleteExpired]...';


GO
CREATE PROCEDURE [dbo].[ecf_SerializableCart_DeleteExpired]
	@ModifiedTo DATETIME,
	@ExcludeName NVARCHAR(256)
AS
BEGIN
	WITH CTE AS (
		SELECT TOP (500) CartId
		FROM SerializableCart
		WHERE Modified <= @ModifiedTo AND Name NOT IN (@ExcludeName)
		ORDER BY Modified DESC)
	DELETE FROM CTE;

	SELECT @@ROWCOUNT
END
GO
 
GO 


 
--beginUpdatingDatabaseVersion 
 
INSERT INTO dbo.SchemaVersion(Major, Minor, Patch, InstallDate) VALUES(10, 0, 33, GETUTCDATE()) 
 
GO 

--endUpdatingDatabaseVersion 
